.Dd 2016-12-31
.Dt CLAV-CLI 1
.Os
.Sh NAME
.Nm clav-cli
.Nd Visualize quivers on console
.Sh SYNOPSIS
.Nm
.Oo
.Fl f
.Ar filename
.Oc
.Sh DESCRIPTION
.Nm
is a text-based program to interact with quivers.  It is intended to be
used in situations where
.Nm clav-sdl
is unusable, and where by-hand computation is inconvenient.
.Sh OPTIONS
.Bl -tag -width Ds
.It Fl f
Start by opening file
.Ar filename ,
which is of the format written by
.Nm
and
.Nm clav-sdl .
If this option is not provided, a rather uninteresting default quiver is loaded.
.El
.Sh INFORMATION
When
.Nm
starts, it shows a sample quiver, which does not have many interesting
properties.
.Pp
Vertices are displayed in a vertical list.  The left-hand column displays
the index of the vertex, the right displays the name.
.Nm
interacts with vertices by index for compactness' sake.
.Pp
Edges are displayed by weight in a matrix.  The entry of row i, column
j is edge weight ε_{ij} of the quiver
.Pq a blank entry represents 0 .
.Sh CONTROL
The quiver is controlled by primitive text commands. No tab
completion/history is implemented. Help is available by typing
.Sq help .
.Pp
The following commands are available.
.Bl -tag -width Ds
.It help
Print a help message.
.It print
Display the quiver, as described in
.Sx INFORMATION.
.It mutate Ar idx
Mutate the quiver at the vertex with index
.Ar idx .
.It mutatename Ar str
Mutate the quiver at the vertex with name
.Ar str .
.It delete Ar idx
Delete the vertex with index
.Ar idx .
.It delete Ar idx-one idx-two
Delete edges between vertices with indices
.Ar idx-one
and
.Ar idx-two .
The order of the two parameters is unimportant.
.It vertex
Create a new vertex, called
.Sq v .
.It edge Ar i Ar j Ar p / Ar q
Add an edge from
.Ar i
to 
.Ar j .
The weights of both directions of the edge will be modifed by the
following formula
.Po where
.Ar i
is 
.Ar idx-one
and
.Ar j
is
.Ar idx-two
.Pc :
.Dl ε_{ij} := ε_{ij} + (p · F_j) / (q · GCD(F_i, F_j))
.Dl ε_{ji} := ε_{ij} - (p · F_i) / (q · GCD(F_i, F_j))
where
.Ar F_i
and 
.Ar F_j
are the fatnesses of the vertices with indices
.Ar i
and 
.Ar j
respectively.
.Pp
Omitting
.Ar q
is permitted; it implies using
.Sq 1
for
.Ar q .
.It rename Ar idx Ar str
Changes the name of the vertex numbered
.Ar idx
.Po which is shown by
.Sq help
.Pc
to be
.Ar str .
.It renamename Ar str1 Ar str2
As
.Sq rename ,
but the vertex is selected by current name. If the name is ambiguous,
this command will fail.
.It incfat Ar idx
Increment the fatness of the vertex at index
.Ar idx
by one.
.It decfat Ar idx
Decrement the fatness of the vertex at index
.Ar idx
by one.
.It save Ar path
Save the current quiver to
.Ar path .
The file will be readable by
.Nm clav-sdl .
.It load Ar path
Load the quiver from
.Ar path
.Pq discarding the current quiver .
The file may have been written by
.Nm clav-sdl .
.El
.Sh EXAMPLES
Example quivers may have been installed along with this program,
typically in
.Pa /usr/share/clav/ .
.Sh SEE ALSO
.Xr clav 1
.Xr clav-cli 1
.Sh BUGS
Edge weights are, for performance reasons
.Po see
.Xr clav-mutation-find 1
.Pc , stored as fractions with
numerator and denominator in system-dependent ranges.  While it probably
will not be an issue for
.Sq interesting
usage, causing edge weights to increase arbitrarily will eventually cause
.Nm
to compute an unrepresentable edge weight.  In this situation,
.Nm
will terminate with a diagnostic message rather than display incorrect
results.
.Pp
Files saved by
.Nm
are readable by
.Nm clav-sdl ,
but because
.Nm
is not graphical, there will be no good x/y information associated with
any vertices created by 
.Nm .
This will probably be confusing until the quiver is rarranged by a user.
.Sh AUTHORS
.An S. Gilles Aq Mt sgilles@math.umd.edu
